// --------------------------
// RP Jobs :: Commands
// --------------------------

if (isPackage(RP_Jobs_Commands))
	deactivatePackage(RP_Jobs_Commands);

package RP_Jobs_Commands
{
	// Fetch client commands and messages
	function ServerCmdMessageSent(%client, %text)
	{
		// Promotion
		if (isEventPending(%client.promotion))
		{
			Promote(%client, %text);
			return;
		}
		Parent::ServerCmdMessageSent(%client, %text);
	}
	
	// Team messages
	function ServerCmdTeamMessageSent(%client, %text)
	{
		if (isObject(RP_MiniGame))
		{
			MessageGroup(%client, %text);
		}
		else
		{
			Parent::ServerCmdTeamMessageSent(%client, %text);
		}
	}
};
RPRegPackage(RP_Jobs_Commands);

// Message in group
function ServerCmdGroup(%client, %v0, %v1, %v2, %v3, %v4, %v5, %v6, %v7, %v8, %v9, %v10, %v11, %v12, %v13, %v14, %v15, %v16, %v17, %v18, %v19, %v20)
{
	if (!$RP::activated)
		return;
	// Prepare text
	%text = trim(%v0 SPC %v1 SPC %v2 SPC %v3 SPC %v4 SPC %v5 SPC %v6 SPC %v7 SPC %v8 SPC %v9 SPC %v10 SPC %v11 SPC %v12 SPC %v13 SPC %v14 SPC %v15 SPC %v16 SPC %v17 SPC %v18 SPC %v19 SPC %v20);
	// Empty text
	if (%text $= "")
		return;
	
	MessageGroup(%client, %text);
}

// Message in group from GUI
function ServerCmdGroupMessageSent(%client, %text)
{
	if (!$RP::activated)
		return;
	// Empty text
	if (%text $= "")
		return;
	MessageGroup(%client, %text);
}

// Message all in a group
function MessageGroup(%client, %text)
{
	if (%text $= "")
		return;
	
	if (!isObject(%client))
		return;
	%job = %client.RPData.value["jobID"];
	%group = $RP::job::group[%job];
	
	// Sending to group
	for (%i = 0; %i < ClientGroup.getCount(); %i++)
	{
		%target = ClientGroup.getObject(%i);
		if ($RP::job::group[%target.RPData.value["jobID"]] $= %group)
			messageClient(%target, '', '\c3[<color:%1>%2\c3] %3: \c7%4', %group, $RP::job::name[%job], %client.name, %text);
	}
}

///////////////////////
// Advanced commands //
///////////////////////

// Change job
function ServerCmdSetJob(%client, %jobID, %n0, %n1, %n2, %n3)
{
	if (!$RP::activated)
		return;
	if (!%client.CheckPrefTrust($RP::pref::server::rankAdvanceCommands))
		return;
	
	%jobID = atoi(%jobID);
	if (%jobID <= 0)
	{
		messageClient(%client, '', "\c6Invalid job.");
		return;
	}
	if ($RP::job::name[%jobID] $= "")
	{
		messageClient(%client, '', "\c6Invalid job ID.");
		return;
	}
	
	%name = trim(%n0 SPC %n1 SPC %n2 SPC %n3);
	%target = (%name $= "") ? %client : findClientByText(%name);
	
	if (!isObject(%target))
	{
		messageClient(%client, '', "\c6Invalid player.");
		return;
	}
	// Avoid spam
	if (%target.RPData.value["jobID"] == %jobID)
	{
		messageClient(%client, '', '\c3%1\c6 already has that job.', %target.name);
		return;
	}
	
	%target.RPData.value["jobID"] = %jobID;
	
	messageClient(%client, '', '\c6You set \c3%1\c6\'s job to \c3%2\c6.', %target.name, $RP::job::name[%jobID]);
	messageClient(%target, '', '\c3%1\c6 changed your job to \c3%2\c6.', %client.name, $RP::job::name[%jobID]);
	
	%target.displayInfo();
}