// --------------------------
// RP Jobs :: User
// --------------------------

if (isPackage(RP_Jobs_User))
	deactivatePackage(RP_Jobs_User);

package RP_Jobs_User
{
	// Activating
	function Player::activateStuff(%player)
	{
		Parent::activateStuff(%player);
		
		// Retreive target
		%obj = %player.GetObjectFromPOW($TypeMasks::PlayerObjectType);
		%client = %player.client;
		if (!%client.CheckLastAction(%obj))
			return 0;
		
		if (!isObject(%obj))
			return 0;
		
		// Player
		if (%obj.getType() & $TypeMasks::PlayerObjectType)
		{
			%target = %obj.client;
			%special = $RP::job::special[%client.RPData.value["jobID"]];
			
			// Healing
			if (firstWord(%special) $= "heal")
			{
				%max = getWord(%special, 1);
				%amount = getRandom(1, %max);
				%obj.addHealth(%client, 0, %amount, 0);
				messageClient(%target, '', '\c3%1\c6 has healed you. \c2+%2 health', %client.name, %amount);
				%client.lastAction = $sim::time;
			}
		}
		
		return 1;
	}
	
	// RP Core
	function GameConnection::FinishRPSpawning(%client, %noRespawn)
	{
		Parent::FinishRPSpawning(%client, %noRespawn);
		
		if (!isObject(%client))
			return;
		
		%player = %client.player;
		if (!isObject(%player))
			return;
		
		// Choose datablock
		%datablock = $RP::job::datablock[%client.RPData.value["jobID"]];
		if (isObject(%datablock))
		{
			%client.RP_PlayerDatablock = %datablock;
			%player.changeDataBlock(%datablock, %client);
		}
		
		if (!%noRespawn)
		{
			// Tourist spawn ( Standard spawn )
			if (%client.RPData.value["jobID"] != 1)
				if (%tSpawn = FindSpawn("jobSpawn", 1))
					%spawn = %tSpawn;
			
			// Job spawn
			if (%tSpawn = FindSpawn("jobSpawn", %client.RPData.value["jobID"]))
				%spawn = %tSpawn;
			
			// Personal spawn
			if (%tSpawn = FindSpawn("personalSpawn", %client))
				%spawn = %tSpawn;
			
			// Jail spawn
			if (RPModExist("Crime") && %client.RPData.value["jail"] > 0)
			{
				if (%tSpawn = FindSpawn("jailSpawn"))
					%spawn = %tSpawn;
			}
			
			// Transfer player
			if (%spawn !$= "")
				%player.setTransform(%spawn);
		}
		
		// Recolor for group
		%group = $RP::job::group[%client.RPData.value["jobID"]];
		if (%group !$= "")
			%player.setShapeNameColor(HexToRGBA(%group));
	}
};
RPRegPackage(RP_Jobs_User);

// Give default equipments for the job
// Overwrote the function for inheritence to work
function Player::RP_giveDefaultEquipment(%player)
{
	%client = %player.client;
	if (!isObject(%client))
		return;
	// Choose source tools
	%tools = (%client.RPData.value["tools"] $= "") ? $RP::job::tools[%client.RPData.value["jobID"]] : %client.RPData.value["tools"];
	
	%player.addTools(%tools);
	
	%client.RPData.value["tools"] = %tools;
}